[TOC]

# 파이썬 코딩 환경



## 1. 개발환경 개요

- 개발환경을 결정
  - 운영체제에 따라.
  - python interpreter
  - 코드 편집기



## 2. 파이썬 인터프리터

- python - 일반적 파이썬
- anaconda - 다양한 과학 계산용 모듈들을 묶어서 패키징

- 플랫폼 독립적인 인터프리터 언어(Interpreted Language)

| 항목      | 컴파일러 언어                                                | 인터프리터 언어                                       |
| --------- | ------------------------------------------------------------ | ----------------------------------------------------- |
| 작동방식  | **소스코드를 기계어로 먼저 번역** , 해당 플랫폼에 최적화되어 프로그램 실행 | 별도의 번역과정 없이 **소스코드를 실행시점에서 해석** |
| 장점      | 실행속도가 빠름                                              | 간단히 작성, 메모리 필요량 적음                       |
| 단점      | 한번에 많은 메모리 필요                                      | 실행속도가 느림                                       |
| 주요 언어 | `C`, `JAVA`, `C++`, `C#`                                     | `Python`, `Scala`                                     |



## 3. 코드 편집기

- 파이썬 코드도 결국엔 일종의 문서
- 코드를 입력할 문서 편집기가 필요함
- text 타입의 문서를 저장하는 모든 편집기 사용 가능
  - vim
  - 메모장
  - vs code
  - pycharm
- 강좌에서는 vscode, jupyter(lab), colab을 사용할 예정



## 4. jupyter

- IPython 커널 기반 대화형 python shell
- 일반적인 터미널 shell + 웹 기반 데이터 분석 Notebook 제공
- 미디어, 텍스트, 코드, 수식 등의 하나의 문서로 표현 가능
- 사실상 데이터분석 Interactive Shell의 표준
- **Ju**lia + **Pyt**hon + **R**

## 5. Colab

- 구글이 개발한 클라우드기반 jupyter notebook
- Google Drive + GCP + jupyter 등이 합쳐져서 사용자가 손쉽게 접근
- 초기 모듈들이 세팅되어있다는 장점
- Google Drive 파일 업로드하여 사용 가능
- VSC 연결하여 사용 가능
- V100 이상의 GPU 무료 사용 가능

### 6. 커맨드 정리

- `conda activate [가상환경]` - conda 가상환경 실행(디폴트 설치 가상환경 base)

- `conda deactivate` - conda 가상환경 종료

- `jupyter notebook` - jupyter 웹 즉시 실행. 커맨드 실행 폴더가 root dir

- Jupyter 커맨드

  - `cmd + return` - 셀 수행(메모리 적재)

  - `opt + return` - 새로운 셀 생성 후 전환

  - `shift + tap` - 툴팁

  - `cmd + <,>` - 들여쓰기, 내어쓰기

  - 작성 중

     

    ```
    esc
    ```

     

    \- 코멘트 모드 (작성중은 에디터 모드)

    - `b` - 아래쪽에 셀 추가
    - `a` - 위쪽에 셀 추가
    - `ii` - 실행 중지
    - `dd` - 셀 삭제
    - `z` - 셀 지우기 취소
    - `shift + m` - 셀 병합
    - `x` - 셀 오려두기
    - `v` - 새 셀 생성 후 붙여넣기
    - `mm` - 마크다운 변환
    - `yy` - 코드로 변환
    - `h` - 단축키 확인

- Colab 커맨드

  - 미묘하게 Jupyter와 다르니 자료를 보고 학습할 것

- VSC 커맨드

  - 드래그 후 `cmd + d` - 드래그한 코드와 같은 코드들을 일괄 지정하여 수정 가능
  - `opt + click` - 다중 커서 설정
  - `opt + up/down` - 드래그 X 시 해당 라인만, 드래그 O 시 해당 범위 통째로 코드 이동
  - `opt + shift + up/down` - 드래그 X 시 해당 라인만, 드래그 O시 해당 범위 통째로 복사하여 코드 이동
  - `opt + shift + i` - 드래그 한 모든 줄의 끝부분에 다중 커서 생성
  - `opt + shift + 드래그` - 현재 커서 위치 기준으로 드래그한 모든 라인에 다중 커서 생성
  - `cmd + return` - 현재 커서 위치와 관계없이 다음 줄로 커서 이동(엔터)
  - `cmd + u` - 이전 커서 위치로 이동
  - `cmd + b` - 프로젝트 디렉토리 사이드바 토글
  - `cmd + p` - 파일 퀵 오픈
  - `cmd + ,` - 유저 세팅 오픈
  - `cmd + k + s` - 단축키 확인