# Variables & List

이번 강의에서는 프로그래밍에서 가장 기초적으로 알아야 할 **변수**에 대해서 배웁니다. 

변수와 함께 그 변수가 물리적으로 저장되는 **메모리**에 대해서 배웁니다.

마지막으로, 한 번에 여러 개의 변수를 함께 저장해서 화면에 표시하거나 필요한 연산을 수행하게 하는 **리스트** 라는 데이터 타입에 대해서 배웁니다.

- [1. variable and memory](#1. variable and memory)
  - [1.1. 변수](#1.1. 변수)
  - [1.2. 변수명 작명법](#1.2. 변수명 작명법)
- [2. Basic operation(간단한 연산)](#2. Basic operation(간단한 연산))
  - [2.1. 기본 자료형](#2.1. 기본 자료형)
  - [2.2. 연산자와 피연산자](#2.2. 연산자와 피연산자)
  - [2.3. 데이터 형변환](#2.3. 데이터 형변환)
- [3. List](#3. List)
  - [3.1. 인덱싱](#3.1. 인덱싱)
  - [3.2. 다양한 데이터 타입을 하나의 List에 넣을 수 있다.](#3.2. 다양한 데이터 타입을 하나의 List에 넣을 수 있다.)
  - [3.3. 패킹과 언패킹](#3.3. 패킹과 언패킹)
  - [3.4. 2차원 리스트](#3.4. 이차원 리스트)

## 1. variable and memory

### 1.1. 변수

- 가장 기초적인 프로그래밍 문법 개념

- 데이터 값을 저장하기 위한 메모리 공간의 프로그래밍 상의 이름

- ```python
  >> a = 3
  >> b = 5
  >> a+b
  8
  ```

- `a`라는 변수에 5를 넣고, `b`라는 변수에 3을 넣는다. 

- 변수는 어디에 저장될까?

  - 변수는 <u>메모리 주소</u>를 가지고 있고, 변수에 들어가는 값은 <u>메모리 주소에 할당</u>됨

- **폰 노이만 아키텍쳐**

  > ![image-20210119161953189](https://user-images.githubusercontent.com/38639633/105004574-868e1a80-5a77-11eb-9073-7b8fc9bd3f2e.png)

- 메모리와 메모리 주소, 값이 있게된다. 

- `선언`이 되는 순간 물리적으로 os에 메모리 공간을 요청하고, 그 저장 공간에 값(value)이 할당되는 것

### 1.2. 변수명 작명법

- 알파벳, 숫자, 언더스코어(_)로 선언이 가능하다. 
-  변수명은 대소문자를 구분함.
- 특별한 의미가 있는 예약어는 쓰지 않는다. 
  - ex) for, if else 등등...



## 2. Basic operation(간단한 연산)

> 간단한 사칙연산, 문자열 처리 등의 연산을 알아야함

1. 기본 자료형
2. 연산자와 피연산자
3. 데이터 형변환

### 2.1. 기본 자료형

![image-20210119162447149](https://user-images.githubusercontent.com/38639633/105004568-855ced80-5a77-11eb-8157-41455a77bd02.png)

굳이 타입을 선언하지 않아도 선언 형태에 따라서 코드의 실행 시점에 타입이 결정된다



**Dynamic typing**

> 인터프리터가 알아서 해석해줌

```java
/* java
*/
Integer first = 100;
Integer second = new Integer(200);
```

```python
# python
first = 100
second = 200
```



### 2.2. 연산자와 피연산자

- `+,-,*,/`와 같은 기호들은 연산자라 칭함
- 연산순서도 실제 연산과 거의 동일하다.
- ** : 제곱
- / : integer 나눔
- // : 몫 , %: 나머지
- += : 증가연산 
  - 반복할때마다 계속 더해짐.
  - a+=1 =>> a에 1씩 계속 더함
- -= : 감소연산



### 2.3. 데이터 형변환

- float()와 int() 등의 함수를 이용해서 데이터 형 변환 가능

- ```python
  >> a = 10
  >> type(a)
  <class 'int'>
  
  >>float(a)
  <class 'float'>
  
  # 아직 a는 int이다. 왜냐면, float(a)를 a에 할당해주지 않았기 때문. 단순 출력했을 뿐...
  >> a
  <class 'int'>
  
  ```

- type이 맞는 것들 끼리만 연산이 가능하다. 

- 예전에는 정수만 저장하면 무한 소수로 표현되었음

  - 정수를 저장할 때 2진수로 저장하기 때문에
  - why 2진수? 
    - 반도체를 사용하기 때문에, 전류가 흐를때1, 흐르지 않을 때 0으로 표현가능함





## 3. List

- list 또는 array라고도 함
- 리스트에는 여러가지 특징이 있음.



### 3.1. 인덱싱

- 리스트에 있는 값들은 주소(offset)을 가짐 

- 각 자릿값에 따라 0, 1, 2, .... 로 주소를 가진다.

- ```python
  >> cities = ['서울','부산','인천','대구','대전','광주','울산','수원']
  >> cities[3:5]
  ['대구','대전']
  ```

- 음수의 경우 순서를 뒤에서부터 카운트 한다.

- [a: b: c]

  - a : 시작 인덱스
  - b : 끝 인덱스
  - c : 몇 칸씩 점프할 것인지

- [::-1]

  - 표시 안해주면 거꾸로 한칸씩 

- 리스트의 `+`연산

  - 리스트의 + 연산은 concatenate로 붙여서 나열된다.

- 리스트의 `*`연산

  - ```python
    >> a = ['a','b','c','d']
    >> a * 2
    ['a','b','c','d','a','b','c','d']
    ```

- List.append(a) : 
  
  - List에 a를 추가
- List.extend(['a','b']) : 
  
  - List에 ['a','b']를 추가



### 3.2. 다양한 데이터 타입을 하나의 List에 넣을 수 있다.

- ```python
  lst = ['안녕',1, 100, arr(['ab','c'])]
  ```

- 시퀀스형 자료형이기 때문에 중첩 시에도 리스트 안에 리스트를 넣을 수 있다.

- ![image-20210119164856554](https://user-images.githubusercontent.com/38639633/105004564-83932a00-5a77-11eb-8a8c-6d7e2e1789dd.png)

- ```python
  >> a = [5,4,3,2,1]
  >> b = [1,2,3,4,5]
  # 메모리 공간이 각각 생김
  >> b = a
  # 선언하는 순간 b가 가리키는 공간이 끊기고 b는 a가 가리키는 것과 같은 공간을 가리킨다.
  >> b
  [5,4,3,2,1]
  
  >> a[3]=100
  [5,4,3,100,1]
  
  >> b
  [5,4,3,100,1]
  
  # 이렇게 하면 b는 a를 복사하지만 같은 곳을 가르키진 않는다. 
  # 따라서 a를 바꿔도 b는 그대로임.
  >> b = a[:]
  ```



### 3.3. 패킹과 언패킹

- 패킹 : 한 변수에 여러 개의 데이터를 넣는 것

- 언패킹 : 한변수의 데이터를 각각의 변수로 반환

- 원소의 갯수만큼 변수를 지정해주면 알아서 각 자리에 맞게 할당된다. 

- ```python
  >> t = [1,2,3]
  >> a,b,c = t
  >> print(a,b,c,t)
  1, 2, 3, [1,2,3]
  ```



### 3.4. 이차원 리스트

- 리스트 안에 리스트를 만들어서 Matrix를 생성하는 방식

- ```python
  a = [1,2,3,4,5]
  b = [2,4,6,8,10]
  c = [1,3,5,7,9]
  score = [a,b,c]
  ```

- 2차원 리스트의 경우 copy할때 인덱싱으로는 안된다. 

  - ```python
    import copy
    copy.deepcopy()
    ```

  - 위와 같이 deepcopy함수를 통해 카피한다. 











































































































