# Function and Console I/O

- [1. 함수](#1. 함수)

  - [1.1 함수의 개요](#1.1. 함수의 개요)
  - [1.2. 함수 선언 문법](#1.2. 함수 선언 문법)
  - [1.3. 함수 수행 순서](#1.3. 함수 수행 순서)
  - [1.4. parameter vs argument](#1.4. parameter vs argument)
  - [1.5. 함수 형태](#1.5. 함수 형태)

- [2. Console in I/O](#2. Console in I/O)

  - [2.1. console i/o - input()](#2.1. console i/o - input())
  - [2.2. console i/o - print()](#2.2. console i/o - print())
  - [2.3. print formatting](#2.3. print formatting)

  

이번 강의에서는 **콘솔 인/아웃**에 대해서 배웁니다.

**함수**란 **프로그램을 개발할 때 사용되는 코드의 논리적 단위**로, 가장 기본적인 코드 개발 방법 중 하나입니다.

또한, **콘솔**은 터미널이라고 불리는 컴퓨터 프로그램으로 **컴퓨터에게 뭔가를 입력해서 컴퓨터가 결과를 출력하게 할 때 사용**합니다.

# 1. 함수

어떤 일을 수행하는 코드의 덩어리

## 1.1. 함수의 개요

```python
def calculate(x,y):
    return x*y #가로 세로를 곱해서 반환
```

- 반복적인 수행을 1회만 작성 후 호출
- 코드를 논리적인 단위로 분리할 수 있다.
- 캡슐화 : 인터페이스만 알면 타인의 코드를 사용



## 1.2. 함수 선언 문법

- 함수이름, 파라미터, indentation, return value(optional)

- 파이썬에서는 함수의 코드 블락을 구분하기 위해 `들여쓰기`를 한다.

  ```python
  def 함수이름(parameter):
      수행문 #1
      수행문 #2
      return 반환값
  ```



## 1.3. 함수 수행 순서

- 함수 부분을 제외한 메인프로그램부터 시작

- 함수호출시 함수부분을 수행 후 되돌아옴

  ```python
  def calculate(x,y):
      return x*y #가로 세로를 곱해서 반환
  
  rec_x = 10
  rec_y = 20
  print('x의 길이',rec_x)#10
  print('y의 길이',rec_y)#20 출력
  
  #넓이 호출
  print('사각형 넓이:', calculate(rec_x, rec_y)) #함수 호출
  ```

  > 1. 기본 문장 실행
  >
  > ```python
  > rec_x = 10
  > rec_y = 20
  > print('x의 길이',rec_x)#10
  > print('y의 길이',rec_y)#20 출력
  > ```
  >
  > 2. 함수 호출
  >
  > ```python
  > calculate(rec_x, rec_y)
  > ```
  >
  > 3. 함수 계산
  >
  > ```python
  > def calculate(x,y):
  >     return x*y #가로 세로를 곱해서 반환
  > ```
  >
  > 4. print문 출력
  >
  > ```python
  > print('사각형 넓이:', calculate(rec_x, rec_y)) #함수 호출
  > ```

- 수학에서의 함수와 프로그래밍에서의 함수는 매우 유사하다.



## 1.4. parameter vs argument

- parameter : 함수의 입력 값 인터페이스
- argument : 실제 함수에 들어가는 값
- 개념적으로는 구분하지만 실제로는 그닥 구분하지 않는다. 



## 1.5. 함수 형태

- parameter 유무와 반환값의 유무에 따라 함수의 형태가 조금씩 다르다

  ![image-20210119171639895](C:\Users\doyeon\AppData\Roaming\Typora\typora-user-images\image-20210119171639895.png)

- 함수 내에서 print문을 찍는것과 return하는 것의 차이를 말한다.

- 화면에 찍힌다고 해도 반환값이 항상 있는 것은 아니다. 



# 2. Console in I/O

## 2.1. console i/o - input()

어떻게 Input Output을 받을 것인가?

- input() 함수를 통해 입력을 받을 수 있다.

   ![image-20210119171957243](C:\Users\doyeon\AppData\Roaming\Typora\typora-user-images\image-20210119171957243.png)![image-20210119172108385](C:\Users\doyeon\AppData\Roaming\Typora\typora-user-images\image-20210119172108385.png)

- sombody라는 변수에 input()을 통한 입력 값을 받고, sombody를 출력하는 모습.
- 콘솔에서 console_example.py를 호출함으로써 입력 및 출력을 실행하는 모습



## 2.2. console i/o - print()

- print()함수 내 여러개의 데이터를 출력할 때 `콤마(,)`를 이용해서 여러 종류를 출력할 수 있다.

- ex)

  - ```python
    >> temp = 100
    >> print('온도는', temp, '도 입니다.')
    온도는 100 도 입니다.
    ```



## 2.3. print formatting

1. %string
2. format함수
3. fstring

- **old school formatting**

- ```python
  >> print('%s 다음에는 %s' %('one','two'))
  one 다음에는 two
  
  >> print('{} 다음에는 {}'.format('one','two'))
  one 다음에는 two
  ```

- %-format 사용시 문자열의 사이즈 및 형태를 제한할 수 있다.

  ![image-20210119173038424](C:\Users\doyeon\AppData\Roaming\Typora\typora-user-images\image-20210119173038424.png)

- **padding**

  - 여유 공간을 지정하여 글자배열 + 소수점 자릿수를 맞출 수 이다. 
  - %-formatting
    - %4s : 4칸을 비우기

  - {}.formatting
    - {0:5s} : 5칸 비우기
    - {0:>5s} : 5칸 비우면서 오른쪽으로 정렬

- **naming**

  - 순서대로 하는 방식이 아니라, dict타입으로 이름을 정해서 위치에 넣어줌

- **f-string**

  ![image-20210119173740807](C:\Users\doyeon\AppData\Roaming\Typora\typora-user-images\image-20210119173740807.png)

  - ```python
    >> value1 = 10
    >> value2 = '문자열'
    >> print(f'{value1}')
    >> print(f'{value2}')
    10
    '문자열'
    ```

  - 문자열, 숫자 상관없이 동일한 형태로 python 3.6이후로 많이 사용된다. 





























































