# Module and Project

이번 강의에서는 파이썬 프로젝트의 기본이 되는 **모듈**과 **패키지**, 그리고 **프로젝트**의 개념에 대해서 배웁니다.

우리는 앞서 파이썬에서 제공하는 여러가지 모듈들을 사용했습니다. 이러한 모듈과 패키지를 구성하고, 실제로 다른 개발자가 만든 모듈을 사용하는 방법까지 이 챕터에서 다루게 됩니다.

내용은 많이 어렵지는 않지만, 알면 여러모로 도움되는 내용이니 많은 연습을 하고 넘어가면 좋겠습니다.

- 프로그램에서는 작은 프로그램 조각들, 모듈들을 모아서 하나의 큰 프로그램을 개발한다.

- 프로그램을 모듈화 시키면 다른 프로그램이 사용하기 쉬움

  - 예) 카카오톡 게임을 위한 카카오톡 접속 모듈

  

- 모듈(module) in Python
  - 빌트인 모듈인 random을 사용
    - ex) import random



# 1. 모듈(Module)

- 파이썬 파일(.py)==module을 의미
- 같은 폴더에 모듈에 해당하는 .py 파일과 사용하는 .py를 저장
- import문을 사용해서 모듈 호출 

## 1.1. namespace

- 모듈을 호출할 때 범위를 정하는 방법
- 모듈 안에는 함수와 클래스가 존재한다. 
- 필요한 함수 혹은 클래스를 호출할 수 있음.
- `from a import b`



# 2. 패키지

- 하나의 대형 프로젝트를 만드는 코드의 묶음

- 다양한 모듈들의 합, 폴더로 연결됨

- `__init__`, `__main__`등 키워드 파일명이 사용됨

- 다양한 오픈 소스들이 모두 패키지로 관리된다. 

- 패키지 만들기

  - 기능들을 세부적으로 나눠 폴더로 만든다. 

  - 각 폴더별로 필요한 모듈 구현

  - 1차 테스트 in python shell

  - 폴더별로 `__init__.py` 구성하기

    - 현재 폴더가 패키지임을 알리는 초기화 스크립트

    - 없을 경우 패키지로 간주하지 않는다. (사실 없어도 상관없다. python 3.3이후부터)

    - 하위 폴더와 py 파일을 모두 포함한다. 

    - import와 `__all__` keyword를 사용한다. in `__init__.py`

      ```python
      __all__ = ['image','sound','stage']
      
      from . import image
      from . import sound
      from . import stage
      ```

      ![image-20210122131805342](https://user-images.githubusercontent.com/38639633/105446009-96467280-5cb4-11eb-9f4a-f1bbedca8e2f.png)

      > 마찬가지로 각 폴더의 `__init__.py`에 사용할 파일을 import 한다. 

  - 프로젝트로 공개가 되면, shell에서 python {폴더명}으로 실행이 가능 



# 3. Virtual Environment

- 대표적인 도구 virtualenv와 conda가 있음

  ![image-20210122132730189](https://user-images.githubusercontent.com/38639633/105446501-95faa700-5cb5-11eb-9bcd-c4678ccd369f.png)

  > 종종 패키지가 c언어로 compile 된 경우에 pip에서는 이를 사용하지 못한다. 

- 가상환경 생성과 패키지 사용에 대한 내용은 생략

































