## 3. Matrix

- matrix
  - vector를 원소로 가지는 2차원 배열
  - numpy에서는 row가 기본 단위 (행벡터가 기본)
  - $$ \begin{bmatrix} X_1 \ X_2 \ \vdots \ X_n \end{bmatrix} $$
  - (Xi: 행벡터 -> i 번째 데이터)
  - $X = (x_{ij})$
  - $X^T = (x_{ji})$
- matrix multiplication
  - $XY = \Big(\sum_kx_{ik}y_{kj}\Big)$
  - X의 i번째 행벡터와, Y의 j번째 열벡터 사이의 내적을 성분으로 가지는 행렬 계산
  - X @ Y (numpy 에서는 @ 사용)
- 두 행렬의 내적
  - $XY^T = \Big(\sum_kx_{ik}y_{jk}\Big)$
  - np.inner: i번째 행벡터와 j번째 행벡터 사이의 내적을 성분으로 가지는 행렬 계산
  - 수학에서 말하는 내적과 다르다. (수학에선 보통 $tr(XY^T)$를 내적으로 계산)
- 행렬의 해석
  - 벡터공간에서 사용되는 연산자(operator)
  - 행렬곱을 통해 벡터를 다른 차원의 공간으로 보낼 수 있음
  - 행렬 A: m차원의 공간에 있는 X를, n차원의 공간에 있는 Z로 보내는 연산자
  - $Z = AX$
  - $$ \begin{bmatrix} z_1 \ z_2 \ \vdots \ z_n \end{bmatrix} = \begin{bmatrix} a_{11} & a_{12} & \cdots && a_{1m} \ a_{21} \ \vdots \ a_{n1} & & & & a_{nm} \end{bmatrix} \begin{bmatrix}x_1 \ x_2 \ \vdots \ x_m \end{bmatrix} $$
- inverse matrix
  - $A^{-1}$
  - 행과 열의 크기가 같고 det != 0 인 경우 계산 가능
  - np.linalg.inv()
- pseudo-inverse (유사역행렬, Moore-Penrose inverse)
  - $A^+ = (A^TA)^{-1}A^T$ (when n >= m)
  - $A^+ = A^T(AA^T)^{-1}$ (when n >= m)
  - np.linalg.pinv()
  - 연립방정식 해 구할 때 이용 가능
  - linear regression equation 찾을 때 이용 가능 ($X\beta = \hat{y} \approx y$)