### [Week 5]: Machine Learning with Graphs - 신기정 교수님

[[Day 21] What is Graph structure](https://github.com/ydy8989/boostcamp/tree/main/Week_5/Day_1)

1. **그래프란 무엇이고 왜 중요할까?**
	- 강의 개요
	- 노드, 간선, 방향성 등 그래프에 대한 간단한 내용 소개
2. **실제 그래프는 어떻게 생겼을까?**
	- 랜덤 그래프 vs 실제 그래프
	- 작은 세상 효과, 두터운 꼬리 분포, 거대 연결 요소...
3. **실습: 그래프의 표현 및 저장**
	- 파이썬 라이브러리 NetworkX
	- 간선 리스트, 인접 리스트, 인접 행렬
	- 파이썬을 이용한 지름 및 군집 계수 분석
4. **과제 1**
	- (Day 21) 그래프를 컴퓨터 언어로 표현하기 (23일 23:59까지 제출) 
	- (Day 22) 페이지랭크 알고리즘 구현하기 (23일 23:59까지 제출)
		- Day 21의 과제 정답 위에 Day 22의 과제를 수행하는 방식이라서 동시에 배포합니다. 각 날짜마다 해당하는 과제만 수행하시면 됩니다 :) 

[[Day 22] 검색 엔진에서의 그래프 / 그래프 in 바이럴 마케팅](https://github.com/ydy8989/boostcamp/tree/main/Week_5/Day_2)

1. **검색 엔진에서는 그래프를 어떻게 활용할까?**
	- 구글 검색 알고리즘: 페이지랭크 알고리즘
	- 노드 중요성
2. **그래프를 바이럴 마케팅에 어떻게 활용할까?**
	- 의사결정 전파모델
	- 확률적 전파 모델
	- 전파 최적화
3. **실습**
	- [Ko-Wikipedia] 검색 엔진
	- 전파 모형 시뮬레이터

[[Day 23] 추천시스템 with graph(basic)](https://github.com/ydy8989/boostcamp/tree/main/Week_5/Day_3)

1.  **그래프 구조 분석**
	- Girvan-Newman 알고리즘
2.  **추천 시스템(기초)**
	- 내용 기반 추천 시스템(Content-based Collaborative Filtering), 협업 필터링(Collaborative Filtering) 등 기본적인 추천 시스템 방법들에 대해 소개합니다.
3. **실습**
	- Girvan-Newman 알고리즘 구현
	- 협업 필터링 구현
4. **과제 2**
	-  UV 분해를 활용하여 추천시스템 구현하기(25일 23:59까지 제출) 

[[Day 24] 추천시스템 with graph(advanced)](https://github.com/ydy8989/boostcamp/tree/main/Week_5/Day_4)

1. **노드 임베딩(Node Embedding)**
	- 인접성 기반, 거리 기반, 랜덤 워크 기반 등 그래프의 정점을 벡터로 표현하는 다양한 임베딩 방법에 대해 학습합니다.
2. **추천 시스템(심화)**
	- 잠재적 인수 모형(Latent Factor Model)에 대해서 학습합니다.
3. **실습**
	- Node2Vec을 사용한 군집 분석 및 정점 분류
	- Surprise 라이브러리와 잠재 인수 모형의 활용

[[Day 25] Graph neural network](https://github.com/ydy8989/boostcamp/tree/main/Week_5/Day_5)

1. **그래프 신경망이란 무엇일까?(기본)**
2. **그래프 신경망이란 무엇일까?(심화)**
3. 실습
	- DGL 라이브러리와 GraphSAGE를 이용한 정점 분류
	- GraphSAGE의 집계 함수 구현
4. **간단한 퀴즈**
5. **신기정 교수님과의 질의응답 시간**(17:00 - 18:00)

 