# (2강) 팔리는 물건

**강의 소개** 

엔지니어는 비즈니스도 잘 알아야 합니다. 우리는 일이 되는 방향의 반대를 상식으로 이해하는 경향이 있는데 이 강의에서는 왜 그런지를 알아봅니다. 

 

**Further Question**

- 이번 강의는 lightweight modeling과 어떤 관계가 있을까? (이 강의를 만든 목적은 무엇일까?)
- 고객의 어떤 문제를 내가 해결할 수 있을까?
- on-device solution의 다른 아이디어는 어떤 것이 있을까?
- Memory 제약이 얼만큼이면 vgg16 모델이 작동을 못하는지 기록해보자
- 이번 강의를 내 손으로 만든다면 나는 어떻게 만들어볼 수 있을까?





## Worth of this time

![image](https://user-images.githubusercontent.com/38639633/111253203-24f0c380-8656-11eb-8cf2-222f0721aea2.png)

- 과거를 등지고 미래를 보는 사람의 시간 vs 미래를 등지고 과거를 보는 사람의 시간
- 남들이 좋다 좋다하는 거대한 모델들과 다르게, 반대로 퍼포먼스를 버리고 경량화를 추구하는 것에 대한 의미를 살펴보자



## 정방향, 역방향

- 시간을 맞춰서 개발을 완료하면 다 된 걸까?

- 학위를 취득하고 공부를 열심히 하면 세상을 다 가질 수 있을까?

- 열심히 하는게 잘 하는 것일까?

- 잘 만들면 잘 팔릴까?

	- 표적 시장이 원하는 '바로 그 제품'을 만들었어도 사지 않는 경우가 발생한다. 

- 고객의 요구 사항을 반영한 개발

	![image](https://user-images.githubusercontent.com/38639633/111253819-25d62500-8657-11eb-8efd-a1db208d6988.png)

	- 원하는 것은 좌측이고, 광고는 가운데처럼 시행한다. 결국 고객이 받는것은 우측이다...
	- 이런일이 왜일어날까?

- 제품 개발 관점과 고객 관점

	- *"우리 팀은 비교적 젊은 나이에 매우 깊이 깨달았다. 만들 만한 가치가 있는 제품이 아니라면 엔지니어 팀이 얼마나 훌륭한지는 아무 의미가 없다는 것이다.* " - 마티 케이건.[인스파이어드] 중
	- 엔지니어링 오리엔티드 thinking을 하다보면 무언가를 빼놓을 수가 있다는 점이다...

- 순서 

	- 새로운 기술을 익히는 최선의 방법은 스스로 문제를 정의한 다음, 새로운 기술을 이용해서 그 문제를 풀어보는 것이다.
		- 이 문제를 풀겠어요!
		- AI 기술, 경량화 기술로 그 문제를 풀겠어요!
		- 동영상을 보겠어요!

- 뭔가를 작동하게 만드는 것이 개발을 잘 하는 것일까? vs 코드를 작성하는 것이 개발을 잘 하는 것일까?

	![image](https://user-images.githubusercontent.com/38639633/111254259-fd9af600-8657-11eb-81a3-25f74dfc1f1f.png)

	- 개발을 하고나면 나오는게 unit test, 버그 테스터, 등... 원래 하는 일보다 할게 많아진다.

	- 한 설문에서 코드를 고치는 일은 약 5%라는 연구 결과가 나타났다. 

		![image](https://user-images.githubusercontent.com/38639633/111254402-536f9e00-8658-11eb-94f1-ab54e8d91c11.png)

- 코드 가지고 하는 일들

	- 구현 중요하다. 하지만 피드백이 더 중요하다. 
	- 프로세스 개선을 위한 코딩의 초점

- 공부 포트폴리오

	- 멘토 : 학습 시간의 80%는 본질 적인 것에 투자하고, 나머지 20%는 프레임워크나 라이브러리를 공부하는식으로 하는 방향도 이다. 

- 불확실한 상황에서의 의사결정

	- 좋은 계획이 좋은 결과로 무조건 귀결되는 것은 아니지만, 사람들은 좋은 결과에 목맬 수 밖에 없다. 
	- 왜냐면 불확실하고 불안해서..
	- 애초에 뭔지 몰라도, 그 과정을 잘 컨트롤하면 본래대로 계획한 것보다 더 좋은 결과로 이어질 수 있다. 

- 확실한 상황에서 $\rightarrow$ 분담 / 불확실한 상황에서 $\rightarrow$ 협업

	![image](https://user-images.githubusercontent.com/38639633/111256473-8025b480-865c-11eb-964c-c2f359ca81dd.png)

	- 분담은 모두가 성공해야 1이지만, 협업은 모두가 실패할 때만 0이다. 



## In AI tasks

- AI의 task는 정말 모델을 만들고 추론하는게 전부일까?

- Problem solving in AI

	![image](https://user-images.githubusercontent.com/38639633/111256658-f2969480-865c-11eb-86cb-d999a092282c.png)

	- 모든 걸 AI로 해결하려는 모습들이 많이 보이고 있다. 

- 고객 만족은 ai로부터?

	- 전혀 별개의 이야기이다. 
	- ![image](https://user-images.githubusercontent.com/38639633/111260403-0e516900-8664-11eb-836b-c4ad0300e6e3.png)
	- 두 가지 관점이 있다. 과거를 잊고 미래 지향적 사고로 AI의 고객 수요를 바라볼 것인지, 혹은 과거를 보며 뒤통수를 미래로 향한채 나아갈 것인지.

- input $\rightarrow$ model $\rightarrow$ output. Clear?

	- ![image](https://user-images.githubusercontent.com/38639633/111260671-99326380-8664-11eb-95a3-c695a35e1965.png)
	- 신경망은 일반적 소프트웨어와 같이 깔끔한 api와 추상화가 가능하다는 인상을 주지만, 실제로는 그렇지 않다.

- AI 모델은 입력에 대한 정확한 출력을 보장하지 않는다. 

	- 

