# 5월 17일 오피스아워 시각화 대시보드 프로젝트 기본 프로세스 - 장유진 멘토님

1. 현업에서의 데이터 시각화
2. 시각화 대시보드 프로젝트 기본 프로세스
3. Business Intelligence Tool(BI Tool)
4. 일상과 취업에 필요한 시각화 능력

## 현업에서의 데이터 시각화

- 시각화의 방향
	- 데이터를 마주하게되면 시각화를 이용해서 데이터를 분석(탐색적 자료 분석, EDA)
	- 분석 결과를 모니터링하여 개발자 뿐만 아니라 여러 이해당사자들과 소통을 할 때 수단이 됨
	- 구체적 사례
		- 차트 정보성 극대화 연구
		- 연구결과 논문에 첨부하기 위한 자료로 사용 등
- 시각화 원칙
	- 다양하게 활용할 수 있지만 공통적인 룰이 있음
		- 상황에 맞게 데이터 왜곡을 하지 않아야 함
		- 차트를 올바르게 사용하는 것이 중요
		- 디자인의 조화
		- Principle of Proportion Ink(시각화 Barchart편 참조)
- 대시보드 예시
	- 코드를 사용한 대시보드(python, d3.js 등)
	- BI 툴을 사용한 대시보드(Tableu, Power BI 등)
		- 이 경우가 좀 더 interactive하긴 함
	- 그러나 도구만 다를뿐, 시각화의 기본 원칙은 같다!

## 기본 프로세스

### 프로세스 정리

1. Discovery Session : 대시보드 제작을 위한 논의
	- 데이터 대상자가 누구인가? 마케팅, 기획, 개발, 경영진 등…
		- 데이터 대상자에 따라 데이터 인지 능력에 차이가 있음
	- 목적
		- 간단하게 데이터를 체크하려고하는건가?
		- 고차원적인 분석을 하기 위한건가?
	- 비즈니스 목표
		- 대시보드 사용 팀의 KPI, 장단기 목표
		- 그 다음 계획과 전략
	- 데이터와 데이터 플랫폼에 대한 권한
		- export해서 사용할 때 권한 문제가 발생하기 십상(사전에 체크 필요)
	- 기존에 사용하던 대시보드가 있는가?
		- 이와 연결하여 유사한 대시보드를 요청할 수 있고, 디자인/구조 등을 참고할 수 있음
	- 대시보드 표시에 사용하는 장치 유형
		- PC라면 PC에 맞는 대시보드, 회의실 TV라면 사이즈에 맞게…
	- 이외에도 다양한 정보 수집
		- 짧은 시간에 많이 수집할 수록 프로세스 전체 과정을 단축시킬 수 있음
2. Data Schema : 대시보드에 사용하게 될 데이터를 모두 정리하여 스키마 생성
	- 대시보드에 포함되어야하는 모든 세그먼트, 필터, 계산된 메트릭 식별 및 생성
	- 스키마를 만들면서 데이터가 없다면 코딩을 사용해 데이터를 생성하기도 함
	- 복잡한 데이터를 확인하기도 하고, 최종사용자와의 소모적인 의사소통을 줄이기 위함
		- 처음에 승인받았는데, 나중에 이 metric이 빠졌다는 소모적인 의사소통
3. Wireframe & Research : 대시보드의 구조를 구상하고 사용하고자 하는 차트 조사
	- 최근에 어떤 차트들이 나왔는지, 어떤게 더 정보력 있을지
	- 기존 템플릿을 먼저 검토하고, 논의/승인된 스키마에 따라 와이어프레임 작성
	- 차트 활용법 계획을 세우고, 와이어프레임 보고 및 승인
4. Dashboard Build: 대시보드 제작
	- 승인된 와이어프레임에 지정된(디스커버리 세션에서 고려했던) 모든 요소 대시보드에 추가
	- 디자인이 생각보다 중요함. -> 브랜드를 고려한 대시보드(디자인, 컬러, 로고)
	- 대시보드 초안을 최종사용자에게 승인받고 최종본 생성
5. QA Testing : 대시보드 & 데이터 품질 검증
	- raw 데이터를 대시보드로 만들때, 데이터가 matching하는지 확인해야함
		- raw 데이터가 대시보드로 나왔을 때 제대로 출력되었는가?
	- Integration 과정에서 데이터 loss가 있었을수도 있으므로
6. Delivery & Run Through : 대시보드 전달 및 보고
	- 최종 사용자에게 전달 및 확인
	- 대시보드 사용 방법에 대해 짧게 세션 진행
		- 피드백/질문을 받고 다음 단계를 논의
	- 필요하다면 BI 툴 사용 교육도 진행

### 유의사항

- 소통은 짧고 굵게
- 제작하는 사람과 사용하는 사람이 다르면 플젝 기간이 지연되는 경우가 많음
	- 다른 개발 프로세스에 비해서…
- 대시보드는 사용자 중심의 용어와 UI를 사용해야하는것을 유의할것
- BI tool을 이용한 대시보드 제작에도 코딩이 필요함 -> 코딩 능력이 있으면 유리
	- 원하는 정보가 없을 때 데이터를 생성하기 위해 코딩이 필요함
	- 조건에 매칭하는 정보를 찾을때 정규표현식을 사용하여 필터를 넣기도 함
- 일하면서 자주 사용하는 도구
	- color picker 크롬 익스텐션
	- Google Drawing
		- 와이어 프레임 그리는 과정을 한번 거쳐봄
	- Data Studio Report Gallery
	- Power BI Data Stories Gallery
	- 등등 참고
	- 구글링이 제일 중요!

## (직접 수행하신) 프로젝트 사례

- 웹사이트 사용자 행동 데이터, e-commerce 데이터 사용
- 목적과 차트 크기에 따라 대시보드 구조가 완전히 달랐음

**대시보드 프로젝트에서는 언제나 최종 사용자를 생각해야한다!**

> 내가 보여주고 싶은게 아니라 최종 사용자가 보고싶은 걸 그려야한다.

공모전 등에서 채점 기준도 결국은 최종 사용자.

## 3. Business Intelligence Tool

파이썬 시각화 외에 BI tool들은 어떤 특징을 갖고 있나?

- 각종 BI 툴 비교
	- Tableau
	- Power BI
	- Data Studio
	- 진짜 수십가지가 있음…
- Tableau : 데스크탑 기반(Windows, Linux, Mac 지원)
	- 장점
		- 시각화 옵션이 굉장히 다양하고 분석 가능한 범위가 넓음
		- 데이터 분석에 적합한 UI
		- 시각적으로 다른 툴들에 비해 예쁨(ㅎㅎ)
		- 각 차트별 필요한 Dimension과 Metric 수가 표시되는 것이 편함
	- 단점
		- 처음 들어가서 프로젝트를 시작할 때 수정 및 고려해야하는 부분이 많음.
			- 모든 차트 및 대시보드 페이지를 개별적 페이지로 생성해야함
			- 업무 복잡도 심화
		- 출력 가능한 포맷이 적음
- Power BI : 데스크탑 기반, 윈도우만 지원. 웹버전은 UI가 다소 깨지고 불편
	- 주변에서 들어봤을 때 Tableau 다음으로 많이 쓴다는 느낌을 받음
	- 장점
		- MS 소프트웨어 그대로 이용 가능
		- AI 시각화 및 기능이 있어 비즈니스 분석가 + 데이터 과학자가 같이 작업 가능
		- R, Pytho 등의 다양한 분석플랫폼과 통합 사용 가능
	- 단점:
		- DAX라는 계산 언어(함수)를 배워야함 -> 아마도 캠퍼들에게는 별로 어렵지 않을것
		- MS 소프트웨어 인프라를 같이 써야 좀 더 유용함
- Data Studio : 웹기반, 무료
	- 장점
		- Tableau나 Qlik에 비해 접근성이 너무 좋고 무료임
		- 구글 product(sheet, marketing platform, cloud platform 등)과 연계 가능
	- 단점
		- 데이터 전처리 기능이 없음
		- 속도가 좀 느림
- Qlik Sense
	- 장점
		- 데이터 처리 엔진이 매우 빠름
		- 여러 데이터 소스에서 더 많은 데이터를 처리 가능
		- 자연어처리, AI 사용 통찰력 등의 고급 기능들이 탑재되어있다고 함
	- 단점
		- 다소 복잡한 시각화라는 느낌이 있음
		- 전처리 기능이 존재하지만 주요 기능이 아니라 아주 좋지는 않음
- Looker : 클라우드 기반 플랫폼
	- 장점
		- 클라우드 인프라 관심있는 기업에게 유리
		- 다른 툴에 비해 고급 분석 기능 발달
	- 단점
		- 기능이 아직 많이 안알려져있음
		- 사용할 수 있는 사람들이 적음
- (번외) 자바스크립트 라이브러리 D3.js : 웹브라우저 상에 동적이고 인터렉티브한 정보시각화를 구현하기 위한 라이브러리
	- BI 툴 연결해서 사용할 수 있음

### Use case 비교

- 개인적 의견으로 추천
	- Tableau -> 가장 대중적인 툴을 쓰고 싶을때
	- Power BI -> 디자인보다 정보성
	- Data studio -> 웹기반 가벼운 시각화가 필요할 때
	- Qlik Sense -> 철저한 데이터 보안성이 필요할때(국가기관에서 비밀정보를 분석할 때 사용하기도 함)
	- Looker -> 기존 BI 툴이 커버하지 못하는 심화된 분석이 필요할 때

**은탄환은 없다**

> 어떤 BI 툴이든 장/단점이 있고 완벽한 툴은 없다. 상황에 최적인 것을 익혀서 사용하자.

## 4. 일상과 취업에 필요한 시각화 능력

### AI 엔지니어에게 필요한 시각화 능력

- 부캠 시각화 강의에서 커버하고 있는 Python 라이브러리, matplolib, seaborn에 익숙한게 가장 중요
- 그리고 데이터에 적합한 시각화 능력
- 시각화 기본 원칙 숙지
- 시각화에 필요한 기초 통계도 알고 있으면 좋음
- BI Tool은 필수 요건이 아니라 우대사항
	- 요구사항이 아닐 가능성이 큼
	- 요구사항이라고 써져있으면 다른 팀과의 협업이 많고, 비즈니스적 이야기를 하는게 많은 팀일 확률이 높음
	- 상황에 따라 BI 툴을 다룰 수 있음을 어필하기 위해 기능을 훑어보고 간단히 생성해보는 정도면 충분

### 데이터 리터러시의 중요성

- 구글 수석 이코노미스트 할 베리안이 앞으로 10년간 모든 비즈니스에서 가장 중요한 능력이라고 강조
- 데이터를 읽고 그 안에 숨겨진 의미를 파악하는 데이터 해독 능력
	- 확률만 보고는 알 수 없다. 절대값을 주목할것

** BI 툴은 AI엔지니어들에게 우대사항이고, 프로그래밍 능력이 더 중요**

> 충분히 집중할 수 있을때 공부하시고, 아니면 프로그래밍부터 공부하세요!

## QA

- 시각화 대회에서는 어떻게 참여하시는지?
	- 데이터를 가지고 어떤 정보를 생성할 수 있을지 하나하나 구상해보는것(본질은 같음)
- 멘토님 정확히 어떤 일을 하시는데 말씀 주실 수 있으세요? 어떤 직무인지 궁금합니다.
	- 제 background는 학석사 통계학이고요.
	- 지금은 Digital analytics분야에서 분석직무를 맡고있습니다.
		- Google Analytics에 있는 데이터를 대부분 다룸
		- 구글 Big Query도 다룸
		- 웹사이트 내에서 데이터를 수집하고 사용하고 인사이트를 얻고, 시각화하고, 해석할 수 있는 전 과정 컨설팅
- 시각화 대시보드를 사용하는 사람들이 반복적으로 보는 부분을 빠르게 반영하면 좋을 거 같은데, BI툴이나 아니면 파이썬 라이브러리에 대시보드 이용자의 사용 로그를 수집하는 기능도 있나요? 예를 들면… 이용자들이 어떤 필터를 여러 번 걸어서 그래프를 보거나 하면 그런 로그를 수집하면 나중에 만들떄 참고할 수 있을거같아서요.
	- 이를 수집하는 경우는 못봤고, 디스커버리 세션이나 최종/중간 논의 때 사용자들의 의견을 받아서 주요 기능에 따라 필터를 넣기도 하고 그렇습니다.
	- 데이터 수집은 불가능하지 않을까요?
- 구글 데이터 양이 엄청 많으실 것 같은데 빅데이터 관련 자격증이나 빅데이터 처리할 수 있는 툴이 BI 툴 안에 내재되어 있나요?
	- 제가 가장 많이 사용하는 Data studio 기준으로 말씀드릴게요.
	- 데이터 스튜디오는 데이터 전처리하는 기능이 내재되어있지 않아서 규모가 큰 데이터의 경우는 일단 big query로 export하고, 거기서 전처리 한 후 data studio로 export합니다.
- GA(Google Analytics) 말씀해주셨는데, GA와 Data Studio가 호환성이 좋나요?
	- 네 굉장히 좋습니다!
	- 일단 데이터 스튜디오가 무료라는 한계점은 있지만, Google에서 관리하는 프로젝트라 구글 서비스들과의 궁합이 좋아요.
	- 단 굉장히 정보량이 많을 경우 데이터 스튜디오는 대시보드 로딩 속도가 좀 느린 편입니다.
- 멘토님이 시각화를 공부하게 된 이유
	- 대시보드 프로젝트를 사용해본지 1년밖에 되지 않고, 대학교/대학원 다닐때는 EDA 하는 정도였는데, 대시보드는 입사후에 시각화 담당 인력이 필요해서 어쩌다 기회가 생겨서 시작하게 되었습니다.
- 시계열 데이터에서 각 다른시기의 성장세?? 비교는 어떻게 하는게 좋을까요??어떤차트를 이용해야할까요?
	- 다른시기의 성장세가 전년도 대비 등의 정보를 말씀하시는건가요?
	- flow에 맞춰져있다면 line plot, 수치가 필요하다면 barchart
- 엔지니어링 측면도 이해하고 계시는 것 같은데 통계와 별도로 AI이나 프로그래밍 공부도 같이 하셨어요?
	- 학사때 정보통계학 + 정보시스템 + 자바같은것도 다 배우긴 했었어요.
	- 입사 이후에 데이터베이스 관리자 직무로 일을 해서 아키텍쳐에 대한 지식이 아주 조금은 있습니다.
		- 엔지니어링을 이해한다고 말하기는 조금 어렵긴하지만…
	- 그리고 프로그래밍은 메인으로 다뤘던 건 R이었고, 그 외에는 python 정도…
	- 지금 많이 다루고 있는건 프론트엔드 language.
		- 웹 데이터를 수집해서 이해해야하기 때문에, html, css, javascript도…
- 현재 현업에서 시계열 분석을 할 때, ML model을 사용하기도 하시나요? (clustering 등)
	- 저희 회사에서 모델링을 완전히 개발하지는 않고, Big Query에 내재된 머신러닝 모델을 사용하곤 합니다.
	- (질문) 어떤 모델을 사용하시나요?
		- 아직 많은 경험은 없어서 나중에 이부분은 채널을 통해 공유드리겠습니다!

추가적인 질문은 시각화 채널에 올려주세요!

Select a repo

Subscribe