# P stage 4 DKT 3주차 목요일 오피스아워 - WEB 101 & Chrome Extension - 서중원 멘토님

부업:연세대 정보대학원 강사
BeBridge CTO(Slid 앱개발사)
AWS 인턴
Equinor 인턴
스타트업 코스폴 Lead Developer

## 1. WEB101

웹 개발이 처음이신 분들을 위한 내용

**World Wide Web**
인터넷을 통해 URL을 기반으로 자료에 접근할 수 있는 정보시스템
접근 방식

- LAN(Local Area Network) - 공유기(스위치) 기준으로 형성된 소규모 네트워크
- WAN(Wide Area Network) - LAN과 LAN사이를 연결하는 광역 네트워크

**다른 컴퓨터로 요청을 보내고 응답받는 방식**

- IP address
	- 인터넷을 통해 디바이스간 통신을 하려면 통신하려는 컴퓨터(디바이스)가 어디에 있는지 주소를 특정해야한다.
- Domain Name
	- IP 주소는 숫자이므로 외우고 다니기 힘들기때문에, 텍스트 주소를 만들어서 IP 주소와 연결시켜놓는다.
- URL(Uniform Resource Locator)
	- Full 주소
	- `[프로토콜]://호스트주소:[포트]/[경로/쿼리스트링]`

**클라이언트 사이드와 서버 사이드**

- 클라이언트 사이드
	- 유저에게 보여지는 부분, 프론트엔드, 앱, 웹사이트
- 서버 사이드
	- 클라이언트 사이드가 요청을 주고받는 부분, 백엔드, 서버/컴퓨터/클라우드

### 서버 사이드 자세히 알아보기

IP 주소만 안다고 해서 접근할 수 있는게 아니라, 해당 컴퓨터에서 받아들일 준비가 되어야한다.
**요청(request)을 대기하면서 요청에 적합한 응답(Response)를 보내준다.**
python으로는 flask나 Django, Fast API 사용.

이 때 서버에서 요청에 대해 어떤 포맷으로 넘겨주느냐도 중요하다.

- txt(단순 텍스트), json(단순 데이터), html(웹사이트), binary(이미지/비디오/오디오)

### 클라이언트 사이드 자세히 알아보기

사용자와 interaction하는 부분이다.
사용자가 입력을 주면, 그에 걸맞는 출력을 보여주는 부분이다. 따라서 어떻게 생각하면 terminal도 클라이언트 사이드라고 볼 수 있다.(상대적 개념)

안드로이드 폰 : java, kotlin
아이폰 : object-c, swift
웹사이트 : html, css, javascript

웹 사이트 관점에서는 웹 브라우저가 OS에 해당한다.(안드로이드 폰에서의 Android OS, 아이폰에서의 iOS처럼)
웹 브라우저는, 일종의 html 파일을 렌더링할 수 있는 에디터 및 뷰어를 일컫는다.(뷰어이기 때문에 PDF를 웹브라우저로 열 수 있는 것!)

### 웹클라이언트

- HTML : 웹사이트 골격
	- Tag 기반, Tag에 따라서 특정 시각적 속성을 가지는 엘리먼트 표시
	- 태그별로 약속된 규칙을 대부분의 (크롬을 중심으로) 브라우저가 따르고 있다.
- CSS : 웹사이트의 시각적 역할
	- HTML 엘리먼트에 시각적 속성을 부여
	- inline(태그 내에 속성 지정), internal(html 파일의 `<head>`태그 내에 css 정의), external(css 확장자로 별도 파일에 작성 후 `<link>`태그로 불러옴)
- Javascript : 동적인 역할(시각적인 것 + 클라이언트 단의 데이터)
	- Java랑 1도 관계 없음.
	- logic을 처리하거나, HTML,CSS element를 조작할 때 사용.
	- CSS와 비슷하게 inline, internal, External 방식이 있음.
	- python처럼 런타임에 interprete되는 인터프리터 언어

### 웹 클라이언트

**서버사이드 렌더링(SSR)**

- 서버가 HTML,CSS,javascript 파일 전체를 리턴
- 브라우저가 그 응답을 기반으로 웹사이트 렌더링

**클라이언트 사이드 렌더링(CSR)**

- 최초 요청시 클라이언트 파트(HTML을 포함하여 앞으로 사용할 모든 UI/UX 요소들)를 한번에 제공
- 추가적인 UI는 서버에서 받은 데이터(json)을 기반으로 재구성

현재는 CSR이 대세.

1. 모바일 어플리케이션이 생기게 된 이후, 모바일 어플리케이션은 html을 렌더링하지 못하므로, 앱을 대응하는 데이터만 넘겨주는 새로운 서버를 개발해야했음.(-> 개발 공수 2배) 이에 따라 기존의 웹개발도 그냥 데이터만 넘겨주자는 의견이 대두됨.
2. 유용한 CSR 웹프레임워크들이 많이 생겨났음(Angular, React, Vue 등…)

### 데모 1 : 이현규 캠퍼님의 MAVIS(마스크 감지 서비스) + 멘토님의 Flask App(SSR)

- setInterval과 canvas를 이용
- 코드는 나중에 주신다고 합니다!

그런데, 이렇게 빈번하게 요청을 보내는 경우 웹서비스로 퍼블릭하게 오픈하기보다는 IoT 디바이스를 활용하는 것도 좋겠죠.
경량화도 수행하면 좀 더 좋을 것 같아요!

### 데모 2 : 조대현 멘토님의 논문 토픽 분류

- 강의에서 제공된 코드를 참고하여 만드셨음!
- Bertforsequenceclassification 모델 사용

## 2. 크롬익스텐션

**크롬 익스텐션 앱 개발**
크롬 : 큰 브라우저, 작은 OS

**어떻게 개발하면 될까?**

- Adblock : 현재 웹페이지에서 광고와 관련된 Tag 지우기
- Momentum : 새탭 생성할 때 내가 작성한 웹페이지 띄우기
- Grammarly : `<textarea>`나 `<input>` 태그 가져오기

### 데모 1 : BooMentum

- CSR로 만든 Momentum 유사 앱
- 코드 제공해드릴게요!

### 데모 2 : Boost Susik, 성민석 멘토님의 모델 사용

- OCR 모델 사용하여, 드래그한 수식의 이미지를 인식하여 수식 코드로 변환
- 크롬 API로 전체 화면 캡쳐한 뒤, 마우스 이벤트와 Canvas사용하여 좌표 지정한 이미지를 Crop하여 사용

### 데모 3 : 조대현 멘토님의 논문 토픽 분류 익스텐션 앱

- 현재 페이지의 논문 토픽을 예측하여 알려주는 앱

## 웹프로그래밍을 해보는 걸 추천하는 이유

**결과물로 만들 수 있다는 것**

- 모델을 실제 결과물로 만들 수 있다는 것.
	- 직접 serving까지 하지 않더라도, 웹화면으로 데모를 보여주면 프로젝트를 훨씬 잘 설명할 수 있습니다.
- 업무 생산성 향상(크롬 익스텐션)
- 실제로 창업 가능
- 시야가 넓어짐
	- 굳이 모델뿐만 아니라 데이터 수집을 위한 어플리케이션도 만들 수 있어요.

시작을 딥러닝으로 했던, 웹으로 했던, 앱으로 했던… 길게 보고 여유있으실때 이것저것 공부해보시면 좋아요.

------

## QA

- 실시간 처리 문제 : 기존의 마스크분류 모델에서 detection과 segmentation을 적용시키려고 하는데, 서버사이드로 하니까 너무 느려지고 있습니다. 혹시 클라이언트단에서 inference를 할 수 있을까요?
	- 말로만 들었는데, pytorch도 javascript가 있다고 합니다.(잘될지는 모르겠어요)
		- tensorflow.js, torch.js도 있다고 합니다.
	- (질문) 데모로 보여주는 정도면 한명만 잘보이는 정도면 될까요?
		- segmentation을 엄청나게 빠르게 구현할 생각이 아니라면, setInterval을 어느정도 타협봐서 inference 시간을 적당히 하시면 좋을것같아요.
	- 따로 연락주시면 더 도와드리도록 하겠습니다.
- 서빙담당 주니어를 뽑을때, 어느정도의 역량을 요구할까요? 자바스크립트를 잘하는사람이면 웹개발자를 뽑을거같고 모델링을 잘하는사람이면 ai 리서처를 뽑을거같은데 그 사이의 스탠스가 애매하지않나 하는 생각이 듭니다. 어느정도의 역량이 필요할까요?
	- 서빙담당이면 아마 웹개발자인 사람들이 더 유리할거같아요.
	- 그렇지만… 사실 웹 개발을 배우는게 그렇게 오래걸리진 않거든요?
		- 학습도 몇 에폭 안되서 수렴됩니다(…)
	- 실제 산업에서 신입 웹개발자에게 요구하는 역량은 6개월 부스트캠프로 충분히 완성되는 수준입니다(그 이후는 1% 싸움인거같아요)
- HTTP와 같은 웹의 기초 개념을 좀 잡고 싶은데 혹시 추천해주실만한 과정이나 자료가 있을까요? HTTP와 같은 웹의 기초 개념을 좀 잡고 싶은데 혹시 추천해주실만한 과정이나 자료가 있을까요?
	- 천천히 듣고싶으시다면 이고잉님의 생활코딩으로 들으셔도 충분합니다.
	- udemy에서 flask web app serving같은거 찾아보셔도 좋을거같습니다(인프런도)
- 멘토님 블로그 있으신가요?
	- [코드도둑](https://codethief.io/)
	- [미디엄](https://thejungwon.medium.com/)
- 9강과 10강에는 현재 내용이 있나요?
	- 9강과 10강은 서버쪽, 모델 serving에 집중된 내용이고, 오늘은 클라이언트단에 관련된 내용입니다.

------

## 마지막으로 하고싶은 말씀

소개팅한다는 느낌으로 면접에 임하지 말고, 상대(기업)를 면접본다는 마인드로 편하게 진행하시는게 더 좋을것같아요.
그리고 소개팅과 마찬가지로 구직도 많이 해보시면 실력이 늘지 않을까요…?

- P stage 4 DKT 3주차 목요일 오피스아워 - WEB 101 & Chrome Extension - 서중원 멘토님
	- [1. WEB101](https://hackmd.io/IvVcQu0yT8umFscH43dFBw?view#1-WEB101)
	- [2. 크롬익스텐션](https://hackmd.io/IvVcQu0yT8umFscH43dFBw?view#2-크롬익스텐션)
	- [웹프로그래밍을 해보는 걸 추천하는 이유](https://hackmd.io/IvVcQu0yT8umFscH43dFBw?view#웹프로그래밍을-해보는-걸-추천하는-이유)
	- [QA](https://hackmd.io/IvVcQu0yT8umFscH43dFBw?view#QA)
	- [마지막으로 하고싶은 말씀](https://hackmd.io/IvVcQu0yT8umFscH43dFBw?view#마지막으로-하고싶은-말씀)

[Expand all](https://hackmd.io/IvVcQu0yT8umFscH43dFBw?view#)[Back to top](https://hackmd.io/IvVcQu0yT8umFscH43dFBw?view#)[Go to bottom](https://hackmd.io/IvVcQu0yT8umFscH43dFBw?view#)

Select a repo

Subscribe